/******************************************************************************
//	apci57s.h
//
//	aPCI-A57Tv\[X
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
/******************************************************************************/

#pragma once

#include <windows.h>
#include "Apci57w.h"

namespace SampleA57 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

		static Apci57w *A57w;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->SuspendLayout();
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"aPCI-A57 Sample";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
		private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e)
		{
			String^ tmp;
			String^ buf;
			short wLogSlot;				// foCXi[
			Apci57w::Resource* Ri;		// \[X
			Apci57w::Mode* Md;			// TvO[h
			int dwDllVer, dwDrvVer;
			int dwSwitchValue;			// [^XCb`̒l
			int dwNumData, dwStatus;
			short* pwData;
			short wDaData;				// D/Af[^
			Byte InValue, OutValue;		// PIOf[^
			int dwSts, vInitArg;
			int i;
			bool bResult;

			A57w = new Apci57w;
			Md   = new Apci57w::Mode;
			Ri   = new Apci57w::Resource;

			// 
			Ri->dwNumMemWindows = 0;
			for (i=0; i<Apci57w::MAX_MEM; i++) {
				Ri->dwMemBase[i]   = 0;
				Ri->dwMemLength[i] = 0;
				Ri->dwMemAttrib[i] = 0;
			}
			Ri->dwNumIOPorts = 0;
			for (i=0; i<Apci57w::MAX_IO; i++) {
				Ri->dwIOPortBase[i]   = 0;
				Ri->dwIOPortLength[i] = 0;
			}
			Ri->dwNumIRQs = 0;
			for (i=0; i<Apci57w::MAX_IRQ; i++) {
				Ri->dwIRQRegisters[i] = 0;
				Ri->dwIRQAttrib[i]    = 0;
			}
			Ri->dwNumDMAs = 0;
			for (i=0; i<Apci57w::MAX_DMA; i++) {
				Ri->dwDMALst[i]    = 0;
				Ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci57w::MAX_RSV; i++)
				Ri->dwReserved1[i] = 0;

			/*---------------------------------------------------------------------------*/
			// o[Wԍ\
			// aPCI-A57 DLL,Driver̃o[Wԍ擾
			if (A57w->GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Apci57w::SLOT_AUTO);
				return;
			}

			buf = String::Concat("GetVersion\n",
									String::Format("DLL: 0x{0:x8}\n", dwDllVer),
									String::Format("DRV: 0x{0:x8}",   dwDrvVer));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// aPCI-A57̎gp錾
			vInitArg = 0;
			wLogSlot = Apci57w::SLOT_AUTO;		// gp̃foCXT܂B
			bResult = A57w->Create(&wLogSlot,	// ꍇA̎̃foCXi[܂B
									NULL,		// EBhEnhȂ̂NULLZbg܂B
												// EBhEnhZbg΁A
												// e탁bZ[W܂B
									0,			// 3ԖڂɃZbgẮAbZ[WID̊
												// ƂȂlłBۂ̃bZ[WID͂̊lɃI
												// tZbg(WM_EOCȂ)̂ƂȂ܂B
									NULL);
			if (bResult == false) {		// foCX܂B
				ErrorMessage(wLogSlot);
				return;
			}
			buf = String::Concat("Created\n\n",
									String::Format("LogSlot: {0:d}", wLogSlot));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// \[X擾
			if (A57w->GetResource(wLogSlot, Ri) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			/*---------------------------------------------------------------------------*/
			// [^XCb`̒l擾
			if (A57w->GetSwitchValue(wLogSlot, &dwSwitchValue) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			buf = String::Concat(String::Format("IO Base Address  \t: 0x{0:x4} - 0x{1:x4}\n", 
													Ri->dwIOPortBase[0], 
													Ri->dwIOPortBase[0] + Ri->dwIOPortLength[0] - 1),
									String::Format("IRQ         \t\t: {0:d}\n", 
													Ri->dwIRQRegisters[0]),
									String::Format("Switch      \t: 0x{0:x}", 
													dwSwitchValue));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------
			//	A/D 
			//---------------------------------------------------------------------------*/
			// TvO[h̐ݒ
			Md->dwChFirst = Apci57w::ADCH_01;	// TvOJn`l(0 ` 7)
			Md->dwChLast  = Apci57w::ADCH_08;	// TvOI`l(0 ` 7)
			Md->cwBuffer  = 256;				// obt@TCYi[hPʁj
			Md->dwTimer   = 0x15;				// ^C}l(0x15 = 500us)
			Md->dwMode	   = Apci57w::MODE_02;	// 샂[h(1`6)
			if (A57w->SetMode(wLogSlot, Md) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			buf = String::Concat("Sampling Mode\n",
									String::Format("TvOJn`l={0:d}\n", 
													Md->dwChFirst),
									String::Format("TvOI`l={0:d}\n", 
													Md->dwChLast), 
									String::Format("obt@TCY={0:d}\n", 
													Md->cwBuffer),
									String::Format("^C}l=0x{0:x}\n", 
													Md->dwTimer),
									String::Format("샂[h={0:d}\n", 
														Md->dwMode));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// TvOJn
			if (A57w->StartSampling(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Sampling Started");

			/*---------------------------------------------------------------------------*/
			// BUFFER FULL܂BUFFER OVERFLOWɂȂ܂ő҂
			do {
					if (A57w->GetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == false) {
						ErrorMessage(wLogSlot);
						return;
					}
					dwSts = dwStatus & (Apci57w::STS_BUFF_FULL | Apci57w::STS_BUFF_OVERFLOW);
			} while (dwSts == 0);

			/*---------------------------------------------------------------------------*/
			// TvO~
			if (A57w->StopSampling(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Sampling Stopped");

			/*---------------------------------------------------------------------------*/
			// TvOEXe[^X̎擾
			if (A57w->GetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			buf = String::Concat("TvOEXe[^X擾\n",
									String::Format("f[^={0:d}\n", dwNumData),
									String::Format("Xe[^X=0x{0:x}", dwStatus));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// TvOς݃f[^̎擾
			if (dwNumData > 0) {
				pwData = (short*)malloc(dwNumData * sizeof(short));
				if (pwData == NULL ) {
					ResultMessage("obt@mۂł܂ł");
					return;
				}
				if (A57w->GetData(wLogSlot, dwNumData, pwData) == false) {
					ErrorMessage(wLogSlot);
					return;
				}

				if (dwNumData > 100)
					dwNumData = 100;

				buf = "TvOς݃f[^擾\n";
				for (i = 0; i < dwNumData; i++) {
					tmp = String::Format("{0:d2} : 0x{1:x4} \t", i, pwData[i]);
					buf = String::Concat(buf, tmp);
					if ((i + 1) % 4 == 0)	// 4 Ŋ؂
						buf = String::Concat(buf, "\n");
				}
				ResultMessage(buf);
				free(pwData);
			}

			/*---------------------------------------------------------------------------
			//	D/A 
			//---------------------------------------------------------------------------*/
			// o̓f[^̐ݒ
			wDaData = 0x0FFF;

			if (A57w->SetData(wLogSlot, Apci57w::DACH_01, wDaData) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			buf = String::Concat("D/Af[^o\n",
									String::Format("D/A Data: 0x{0:x2}", wDaData));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------
			//	PIO 
			//---------------------------------------------------------------------------*/
			// Cӂ̃f[^o
			// o̓f[^ AAh
			OutValue = 0xAA;

			if (A57w->OutPort(wLogSlot, OutValue) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			buf = String::Concat("f[^o\n",
									String::Format("Out Data: 0x{0:x2}", OutValue));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// f[^ǂݍ
			InValue = 0x00;

			if (A57w->InPort(wLogSlot, &InValue) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			buf = String::Concat("f[^\n",
									String::Format("In Data: 0x{0:x2}", InValue));
			ResultMessage(buf);

			/*---------------------------------------------------------------------------*/
			// aPCI-A57̎gpJ
			if (A57w->Close(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Closed");
			this->Close();
		}

		// ʂ\
		private: void ResultMessage(String^ pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text,
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		// װүނ\
		private: void ErrorMessage(short wLogSlot)
		{
			int dwRes = A57w->GetLastError(wLogSlot);
			String^ szbuf;

			switch (dwRes) {
				case Apci57w::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szbuf = String::Concat("System error\n\n",
											String::Format("Error code: 0x{0:x8}", dwRes));
					break;
				default:
					szbuf = String::Concat("aPCI-A57 error\n\n",
											String::Format("Error code: 0x{0:x8}", dwRes));
					break;
			}
			MessageBox::Show(szbuf, "aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}

