Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       apci57.bas
'
'       aPCI-A57 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' őXbg
Global Const APCI57_MAX_SLOTS = 16

' _Xbgw
Global Const APCI57_SLOT_AUTO = &HFFFF

' G[R[h̒`
Global Const APCI57_SUCCESS = 0                      ' I
Global Const APCI57_ERR_NO_DEVICE = 5000             ' No device or not an aPCI-A57
Global Const APCI57_ERR_RESOURCE = 5001              ' Resource exhaustion
Global Const APCI57_ERR_INVALID_ARG = 5002           ' Invalid argument(s)
Global Const APCI57_ERR_SLOT = 5003                  ' _Xbgԍsłi܂͌܂j
Global Const APCI57_ERR_CHANNEL = 5004               ' `lw肪sł
Global Const APCI57_ERR_TIMER = 5005                 ' ^C}lsł
Global Const APCI57_ERR_NOT_ENOUGH_MEM = 5006        ' \ȃmۂł܂ł
Global Const APCI57_ERR_NUMDATA = 5007               ' w肳ꂽ̃f[^obt@ɑ݂܂
Global Const APCI57_ERR_NOT_CREATED = 5008           ' foCXNGCgĂ܂
Global Const APCI57_ERR_START = 5009                 ' X^[gɎs܂B
Global Const APCI57_ERR_INVALID_FUNC = 5010          ' Ȋ֐Ăяoł
Global Const APCI57_ERR_IN_USE = 5011                ' gp̃foCXł(NT)
Global Const APCI57_ERR_INTERNAL = 5100              ' Send mail to us
Global Const APCI57_ERR_UNKNOWN = 5101               ' Help me!

' TvO[h̒`
                                            ' START  SAMPLING  CLK   obt@[h
Global Const APCI57_MODE_01 = 1             ' soft   single    ---   hCo
Global Const APCI57_MODE_02 = 2             ' soft   burst     timer hCo
Global Const APCI57_MODE_03 = 3             ' extrg  single    ---   hCo
Global Const APCI57_MODE_04 = 4             ' extrg  burst     timer hCo
Global Const APCI57_MODE_05 = 5             ' soft   burst     timer foCX
Global Const APCI57_MODE_06 = 6             ' extrg  burst     timer foCX


' bZ[W
' Apci57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
' ItZbglbZ[Wo܂B
#If WM_EOC Then
#Else
Global Const WM_EOC = 0                     ' VOTvO̊
Global Const WM_BUFF_HALF_FULL = 1          ' hCoOobt@̃n[tt
Global Const WM_BUFF_FULL = 2               ' hCoOobt@̃t
Global Const WM_BUFF_OVERFLOW = 3           ' hCoOobt@̃I[o[t[
Global Const WM_SAMPLING_OVERRUN = 4        ' `lEI[gECNg̃I[o[
#End If ' WM_EOC

' foCXXe[^XR[h
Global Const APCI57_STS_SAMPLING = &H1
Global Const APCI57_STS_EOC = &H2
Global Const APCI57_STS_BUFF_HALF_FULL = &H4
Global Const APCI57_STS_BUFF_FULL = &H8
Global Const APCI57_STS_BUFF_OVERFLOW = &H10
Global Const APCI57_STS_SAMPLING_OVERRUN = &H20

' A/D`lݒl͈̔
Global Const APCI57_ADCH_FIRST = 0
Global Const APCI57_ADCH_LAST = 7

' A/D`lݒl
Global Const APCI57_ADCH_01 = 0
Global Const APCI57_ADCH_02 = 1
Global Const APCI57_ADCH_03 = 2
Global Const APCI57_ADCH_04 = 3
Global Const APCI57_ADCH_05 = 4
Global Const APCI57_ADCH_06 = 5
Global Const APCI57_ADCH_07 = 6
Global Const APCI57_ADCH_08 = 7

' D/A`lݒl
Global Const APCI57_DACH_01 = 0
Global Const APCI57_DACH_02 = 1

' I/O\[XzE
Global Const APCI57_MAX_MEM = 9                  ' MAX_MEM_REGISTERS
Global Const APCI57_MAX_IO = 20                  ' MAX_IO_PORTS
Global Const APCI57_MAX_IRQ = 7                  ' MAX_IRQS
Global Const APCI57_MAX_DMA = 7                  ' MAX_DMA_CHANNELS

' ***** I/O\[X\ *****
' YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B
Type APCI57RESOURCE
    dwNumMemWindows As Long                     ' EBhE
    dwMemBase(1 To APCI57_MAX_MEM) As Long      ' EBhEJnAhX
    dwMemLength(1 To APCI57_MAX_MEM) As Long    ' EBhE
    dwMemAttrib(1 To APCI57_MAX_MEM) As Long    ' EBhE
    dwNumIOPorts As Long                        ' I/O|[g
    dwIOPortBase(1 To APCI57_MAX_IO) As Long    ' I/O|[gJnAhX
    dwIOPortLength(1 To APCI57_MAX_IO) As Long  ' I/O|[g
    dwNumIRQs As Long                           ' IRQ
    dwIRQRegisters(1 To APCI57_MAX_IRQ) As Long ' IRQԍ
    dwIRQAttrib(1 To APCI57_MAX_IRQ) As Long    ' IRQ
    dwNumDMAs As Long                           ' DMA`l
    dwDMALst(1 To APCI57_MAX_DMA) As Long       ' DMA`l
    dwDMAAttrib(1 To APCI57_MAX_DMA) As Long    ' DMA`l
    dwReserved1(1 To 3) As Long                 ' \
End Type

' ***** TvO[h\ *****
' YfoCX̃TvO[hɊւDriver֓n߂̍\́B
' iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB
Type APCI57MODE
    dwChFirst As Long       ' TvOJn`l(0 ` 7)
    dwChLast As Long        ' TvOI`l(0 ` 7)
    cwBuffer As Long        ' obt@TCYi[hPʁj
    dwTimer As Long         ' ^C}l(00H ` 3FH)
    dwMode As Long          ' 샂[h(1 ` 6)
End Type

'-----------------------------------------------------------
' API Functions
'-----------------------------------------------------------

Public Declare Function Apci57GetVersion Lib "apci57" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long
Public Declare Function Apci57Create Lib "apci57" (ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Any) As Long
Public Declare Function Apci57Close Lib "apci57" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci57GetResource Lib "apci57" (ByVal wLogSlot As Integer, ByRef pres As APCI57RESOURCE) As Long
Public Declare Function Apci57GetSwitchValue Lib "apci57" (ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Long
Public Declare Function Apci57SetMode Lib "apci57" (ByVal wLogSlot As Integer, ByRef pcmode As APCI57MODE) As Long
Public Declare Function Apci57StartSampling Lib "apci57" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci57StopSampling Lib "apci57" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci57GetSamplingStatus Lib "apci57" (ByVal wLogSlot As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Long
Public Declare Function Apci57GetData Lib "apci57" (ByVal wLogSlot As Integer, ByVal cwNumData As Long, ByRef pwData As Integer) As Long
Public Declare Function Apci57SetData Lib "apci57" (ByVal wLogSlot As Integer, ByVal wChData As Integer, ByVal wDaData As Integer) As Long
Public Declare Function Apci57InPort Lib "apci57" (ByVal wLogSlot As Integer, ByRef pbInValue As Byte) As Long
Public Declare Function Apci57OutPort Lib "apci57" (ByVal wLogSlot As Integer, ByVal bOutValue As Byte) As Long
Public Declare Function Apci57GetLastError Lib "apci57" (ByVal wLogSlot As Integer) As Long
