/*============================================================================
//	apci57w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#pragma once

#include <windows.h>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

#ifdef MessageBox
#undef MessageBox
#endif

// NX̐錾
__gc public class Apci57w;

__gc public class Apci57w
{
private:
	static int mErrWradll = SUCCESS;	// bp[֐G[

public:
	// őXbg
	static const int	MAX_SLOTS				= 16;

	// _Xbgw
	static const short	SLOT_AUTO				= -1;

	// G[R[h̒`
	static const int	ERR_INTERNAL			= 5100;	// Send mail to us
	static const int	ERR_UNKNOWN				= 5101;	// Help me!
	static const int	SUCCESS					= 0;	// I
	static const int	ERR_NO_DEVICE			= 5000;	// No device or not an aPCI-A57
	static const int	ERR_RESOURCE			= 5001;	// Resource exhaustion
	static const int	ERR_INVALID_ARG			= 5002;	// Invalid argument(s)
	static const int	ERR_SLOT				= 5003;	// _Xbgԍsłi܂͌܂j
	static const int	ERR_CHANNEL				= 5004;	// `lw肪sł
	static const int	ERR_TIMER				= 5005;	// ^C}lsł
	static const int	ERR_NOT_ENOUGH_MEM		= 5006;	// \ȃmۂł܂ł
	static const int	ERR_NUMDATA				= 5007;	// w肳ꂽ̃f[^obt@ɑ݂܂
	static const int	ERR_NOT_CREATED			= 5008;	// foCXNGCgĂ܂
	static const int	ERR_START				= 5009;	// X^[gɎs܂B
	static const int	ERR_INVALID_FUNC		= 5010;	// Ȋ֐Ăяoł
	static const int	ERR_IN_USE				= 5011;	// gp̃foCXł(NT)
	static const int	ERR_FIFO				= 5012;	// FIFOڂĂȂ
	static const int	ERR_WRAPDLL				= -1;	// bp[֐G[

	// TvO[h̒`
	//													// START  SAMPLING	CLK    obt@[h
	static const int	MODE_01					= 1;	// soft	  single	---    hCo
	static const int	MODE_02					= 2;	// soft	  burst		timer@hCo
	static const int	MODE_03					= 3;	// extrg  single	---@@hCo
	static const int	MODE_04					= 4;	// extrg  burst		timer@hCo
	static const int	MODE_05					= 5;	// soft	  burst		timer@foCX
	static const int	MODE_06					= 6;	// extrg  burst		timer@foCX

	// bZ[W
	// Apci57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
	// ItZbglbZ[Wo܂B
	static const int	WM_EOC					= 0;	// VOTvO̊
	static const int	WM_BUFF_HALF_FULL		= 1;	// hCoOobt@̃n[tt
	static const int	WM_BUFF_FULL			= 2;	// hCoOobt@̃t
	static const int	WM_BUFF_OVERFLOW		= 3;	// hCoOobt@̃I[o[t[
	static const int	WM_SAMPLING_OVERRUN		= 4;	// `lEI[gECNg̃I[o[

	// foCXXe[^XR[h
	static const int	STS_SAMPLING			= 0x01;
	static const int	STS_EOC					= 0x02;
	static const int	STS_BUFF_HALF_FULL		= 0x04;
	static const int	STS_BUFF_FULL			= 0x08;
	static const int	STS_BUFF_OVERFLOW		= 0x10;
	static const int	STS_SAMPLING_OVERRUN	= 0x20;

	// A/D`lݒl͈̔
	static const int	ADCH_FIRST				= 0;
	static const int	ADCH_LAST				= 7;

	// A/D`lݒl
	static const int	ADCH_01					= 0;
	static const int	ADCH_02					= 1;
	static const int	ADCH_03					= 2;
	static const int	ADCH_04					= 3;
	static const int	ADCH_05					= 4;
	static const int	ADCH_06					= 5;
	static const int	ADCH_07					= 6;
	static const int	ADCH_08					= 7;

	// D/A`lݒl
	static const int	DACH_01					= 0;
	static const int	DACH_02					= 1;

	// I/O\[XzE
	static const int	MAX_MEM					= 9;	// MAX_MEM_REGISTERS
	static const int	MAX_IO					= 20;	// MAX_IO_PORTS
	static const int	MAX_IRQ					= 7;	// MAX_IRQS
	static const int	MAX_DMA					= 7;	// MAX_DMA_CHANNELS
	static const int	MAX_RSV					= 3;	// MAX_Reserved1

	// \[X
	[StructLayout(LayoutKind::Sequential)]
	__gc class Resource
	{
	public:
		Int32 dwNumMemWindows;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_MEM)]
		Int32 dwMemBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_MEM)]
		Int32 dwMemLength[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_MEM)]
		Int32 dwMemAttrib[];
		Int32 dwNumIOPorts;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_IO)]
		Int32 dwIOPortBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_IO)]
		Int32 dwIOPortLength[];
		Int32 dwNumIRQs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_IRQ)]
		Int32 dwIRQRegisters[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_IRQ)]
		Int32 dwIRQAttrib[];
		Int32 dwNumDMAs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_DMA)]
		Int32 dwDMALst[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_DMA)]
		Int32 dwDMAAttrib[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci57w::MAX_RSV)]
		Int32 dwReserved1[];
	};

	// TvO[h
	[StructLayout(LayoutKind::Sequential)]
	__gc class Mode
	{
	public:
		Int32 dwChFirst;	// TvOJn`l(0 ` 7) 
		Int32 dwChLast;		// TvOI`l(0 ` 7)
		Int32 cwBuffer;		// obt@TCYi[hPʁj
		Int32 dwTimer;		// ^C}l(00H ` 3FH)
		Int32 dwMode;		// 샂[h(1 ` 6)
	};

	// API
	[DllImport("apci57.dll")]
	static bool Apci57GetVersion(int* pdwDllVer, int* pdwDrvVer);
	[DllImport("apci57.dll")]
	static bool Apci57Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg);
	[DllImport("apci57.dll")]
	static bool Apci57Close(short wLogSlot);
	[DllImport("apci57.dll")]
	static bool Apci57GetResource(short wLogSlot, [In][Out] Resource* res);
	[DllImport("apci57.dll")]
	static bool Apci57GetSwitchValue(short wLogSlot, int* dwSwVal);
	[DllImport("apci57.dll")]
	static bool Apci57SetMode(short wLogSlot, [In][Out] Mode* mode);
	[DllImport("apci57.dll")]
	static bool Apci57StartSampling(short wLogSlot);
	[DllImport("apci57.dll")]
	static bool Apci57StopSampling(short wLogSlot);
	[DllImport("apci57.dll")]
	static bool Apci57GetSamplingStatus(short wLogSlot, int* lpcwNumData, int* lpdwStatus);
	[DllImport("apci57.dll")]
	static bool Apci57GetData(short wLogSlot, int cwNumData, short* lpwData);
	[DllImport("apci57.dll")]
	static bool Apci57SetData(short wLogSlot, short wChData, short wDaData);
	[DllImport("apci57.dll")]
	static bool Apci57InPort(short wLogSlot, Byte* lpbInValue);
	[DllImport("apci57.dll")]
	static bool Apci57OutPort(short wLogSlot, Byte bOutValue);
	[DllImport("apci57.dll")]
	static int Apci57GetLastError(short wLogSlot);


	//***************************************************************************
	// 	  aPCI-A57 DLL,Driver̃o[Wԍ擾
	// 	  pdwDllVer DLLo[Wԍi[AhX
	//		  pdwDrvVer Drivero[Wԍi[AhX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool GetVersion(int* pdwDllVer, int* pdwDrvVer)
	{
		try {
			return Apci57GetVersion(pdwDllVer, pdwDrvVer);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  aPCI-A57̔Cӂ̃foCX̎gp錾
	// 	  pwLogSlot gpfoCXi[AhX
	//		  hWnd		bZ[W𑗂EBhEnh
	//		  uWMBase	ƂȂ郁bZ[WID
	//		  pvInitArg gp(NULLZbg)
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg)
	{
		try {
			return Apci57Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  aPCI-A57̔Cӂ̃foCX̎gpJ
	// 	  wLogSlot gpfoCX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool Close(short wLogSlot)
	{
		try {
			return Apci57Close(wLogSlot);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  wfoCX̃\[X擾
	// 	  wLogSlot ׂfoCX
	//		  pres	   \[Xi[\̂̃AhX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool GetResource(short wLogSlot, [In][Out] Resource* res)
	{
		try {
			return Apci57GetResource(wLogSlot, res);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	//***************************************************************************
	// 	  [^XCb`̒l擾
	// 	  wLogSlot		 ׂfoCX
	//		  pdwSwitchValue [^XCb`̒l
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool GetSwitchValue(short wLogSlot, int* dwSwVal)
	{
		try {
			return Apci57GetSwitchValue(wLogSlot, dwSwVal);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  TvO[h̐ݒ
	// 	  wLogSlot ݒ肷foCX
	//		  pcmode   [hݒf[^̃AhX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool SetMode(short wLogSlot, [In][Out] Mode* md)
	{
		try {
			return Apci57SetMode(wLogSlot, md);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  TvOJn
	// 	  wLogSlot JnfoCX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool StartSampling(short wLogSlot)
	{
		try {
			return Apci57StartSampling(wLogSlot);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  TvO~
	// 	  wLogSlot ~foCX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool StopSampling(short wLogSlot)
	{
		try {
			return Apci57StopSampling(wLogSlot);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  TvOEXe[^X̎擾
	// 	  wLogSlot	 擾foCX
	//		  pcwNumData f[^obt@AhX
	//		  pdwStatus	 Xe[^XAhX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool GetSamplingStatus(short wLogSlot, int* lpcwNumData, int* lpdwStatus)
	{
		try {
			return Apci57GetSamplingStatus(wLogSlot, lpcwNumData, lpdwStatus);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  TvOς݃f[^̎擾
	// 	  wLogSlot	擾foCX
	//		  cwNumData vf[^
	//		  pwData	f[^obt@ւ̃AhX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool GetData(short wLogSlot, int cwNumData, short* lpwData)
	{
		try {
			return Apci57GetData(wLogSlot, cwNumData, lpwData);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  D/Af[^̏o
	// 	  wLogSlot	o͂foCX
	//		  wChData	݃`lw
	//		  wDaData	o͂D/Af[^
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool SetData(short wLogSlot, short wChData, short wDaData)
	{
		try {
			return Apci57SetData(wLogSlot, wChData, wDaData);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  Cӂ̃|[gf[^
	// 	  wLogSlot	͂foCX
	//		  pbInValue ̓f[^i[AhX
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool InPort(short wLogSlot, Byte* lpbInValue)
	{
		try {
			return Apci57InPort(wLogSlot, lpbInValue);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  Cӂ̃|[gփf[^o
	// 	  wLogSlot	o͂foCX
	//		  bOutValue o͂f[^
	// ߂l  true
	//		  s false
	//***************************************************************************
	static bool OutPort(short wLogSlot, Byte bOutValue)
	{
		try {
			return Apci57OutPort(wLogSlot, bOutValue);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	//***************************************************************************
	// 	  aPCI-A57̃G[R[h
	// 	  wLogSlot	G[foCX
	// ߂l G[R[h
	//***************************************************************************
	static int GetLastError(short wLogSlot)
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Apci57GetLastError(wLogSlot);
			}
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-A57 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
	}

};
